/*
PSPGameInfo - By Mickael2054
*/

//Add LIB-->>
#include <pspkernel.h>
#include <pspdebug.h>
#include <psppower.h>
#include <pspctrl.h>
#include <pspmoduleinfo.h>
#include <stdio.h>
#include <pspdisplay.h>
#include <psprtc.h>
#include <systemctrl.h>
#include <string.h>
#include <psploadexec_kernel.h>

#include <pspiofilemgr.h>
#include <stdlib.h>

#include "screenshot.h"


//define-->>

//DISPLAY
#define printf	pspDebugScreenPrintf

//COLORS
#define RGB(r, g, b) ((r)|((g)<<8)|((b)<<16))

//POWER DEL-->>
#define POWER_LED 2
#define STATE_ON 1
#define STATE_OFF 0

//PAD-->>
#define PSP_CTRL_VOLUP 0x100000
#define PSP_CTRL_VOLDOWN 0x200000
#define PSP_CTRL_HOME 0x010000
#define PSP_CTRL_HOLD 0x020000
#define PSP_CTRL_NOTE 0x800000
#define PSP_CTRL_SCREEN 0x400000
#define PSP_CTRL_WLAN_UP 0x040000
#define PSP_CTRL_REMOTE 0x080000
#define PSP_CTRL_DISC 0x1000000
#define PSP_CTRL_MS 0x2000000


//0x1000 = kernel mode
PSP_MODULE_INFO("PSPGameInfo", 0x1000, 1, 1);


int batteryLifeTime = 0;
int powerLocked = 0;

char blittScreen[25];
char blittScreenAll[15];
char blittScreenAll2[15];

int displayBattery = 0;
int displayTemp = 0;
int displayTime = 0;

//COLORS
int white = RGB(255, 255, 255);
int black = RGB(0, 0, 0);
int blue = RGB(0, 0, 255);
int red = RGB(255, 0, 0);


int led_state = STATE_ON;

int curBrightness = 50;
char brightnessP;

int stat=0;

int blittWarning = 0;
int blittWarningShut = 0;


char screenshotname[30];
int screenshotname_c = 1;

FILE* screenshot_file = NULL;

extern u8 msx[];
static u32 fcolor = 0x00ffffff;
static u32 bcolor = 0xff000000;


//Brightness--------------->>
void sceDisplay_driver_9E3C6DC6(int a0,int a1);//a0 0-100,a1 = 0/1 (set to 0)
#define sceDisplaySetBrightness sceDisplay_driver_9E3C6DC6
void sceDisplay_driver_31C4BAA8(int *a0,int *a1);
#define sceDisplayGetBrightness sceDisplay_driver_31C4BAA8
int sceDisplayEnable(void);
int sceDisplayDisable(void);
//------------------
void pause(int time_in_ms);
void blit_string(int x,int y,char* str,u32 color);
void blit_messageGame(char* message,int time_in_ms);
void SetBrightnessM(int mode);
int build_args(char *args, const char *execfile, int argc, char **argv);
int loadStartModule(const char *name, int argc, char **argv);
void lockPower();
void ledP();

static u32 adjust_alpha(u32 col);
void blit_messageGame(char* message,int time_in_ms);
int blit_prx(int sx,int sy,const char *msg,int fg_col,int bg_col);
void blit_messageGameXY (int X,int Y,char* message,int time_in_ms);
void printInBreak(int X, int Y, char* message, int time_in_ms);


//////////////////////////////////////////////////////////////////////

//main thread-->>
int main_thread(SceSize args, void *argp)
{

SceCtrlData pad;

   //initialise l'ecran
   pspDebugScreenInit();

   //desactive l'arriere plan
   pspDebugScreenEnableBackColor(0);

sceKernelDelayThread(10000000);

    	sceCtrlPeekBufferPositive(&pad, 1);

   while(1)
   {


	if (displayBattery == 1)
	 {
        sprintf(blittScreenAll,"%d%%", scePowerGetBatteryLifePercent());
        blit_prx(0,0,blittScreenAll,0xFFFFFF,0xFF000000);
	 }

	 if (displayTime == 1)
	 {
        pspTime psptime;
        sceRtcGetCurrentClockLocalTime(&psptime);

        sprintf(blittScreenAll,"%02u:%02u:%02u", psptime.hour, psptime.minutes, psptime.seconds);
        blit_prx(30,0,blittScreenAll,0xFFFFFF,0xFF000000);
	 }

    if (displayTemp == 1)
      {
        sprintf(blittScreenAll2,"\n%d deg C", scePowerGetBatteryTemp());
        blit_prx(0,0,blittScreenAll2,0xFFFFFF,0xFF000000);
      }



      // If battery is low-->>
    if (scePowerGetBatteryLifePercent() < 10 && scePowerIsPowerOnline()!= 1 && blittWarning == 0)
    {

            sceSysconCtrlLED(POWER_LED,STATE_ON);
            led_state = STATE_ON;

            batteryLifeTime = scePowerGetBatteryLifeTime();
            sprintf(blittScreen,"WARNING your battery is low! %d%% (%02dh %02dm)", scePowerGetBatteryLifePercent(), batteryLifeTime/60, batteryLifeTime-(batteryLifeTime/60*60));

            blit_messageGameXY (13, 25, blittScreen, 2000);
            printInBreak(13, 25, blittScreen, 4000);

            blittWarning = 1;

    }





        // If battery is very low-->>
    if (scePowerGetBatteryLifePercent() < 5 && scePowerIsPowerOnline()!= 1 && blittWarningShut == 0)
    {

            sceSysconCtrlLED(POWER_LED,STATE_ON);
            led_state = STATE_ON;

                    batteryLifeTime = scePowerGetBatteryLifeTime();

                    sprintf(blittScreen,"WARNING your battery is very low! %d%% (%02dh %02dm)", scePowerGetBatteryLifePercent(), batteryLifeTime/60, batteryLifeTime-(batteryLifeTime/60*60));

                    blit_messageGameXY (12, 25, blittScreen, 2000);
                    printInBreak(12, 25, blittScreen, 4000);

                    blittWarningShut = 1;

                    scePowerRequestSuspend();
    }




    if (scePowerGetBatteryLifePercent() > 10 && blittWarning == 1)
    {
    blittWarning = 0;
    blittWarningShut = 0;
    }

    if (scePowerIsPowerOnline() == 1 && blittWarning == 1)
    {
    blittWarning = 0;
    blittWarningShut = 0;
    }



//PAD-------------------------------->
sceCtrlPeekBufferPositive(&pad, 1);


    if (pad.Buttons & PSP_CTRL_NOTE)
	 {
	     if (displayBattery == 0 && displayTemp == 0)
	     {
            displayBattery = 1;
	     }


	     else if (displayBattery == 1 && displayTime == 0)
	     {
            displayTime = 1;
	     }


	     else if (displayBattery == 1 && displayTime == 1 && displayTemp == 0)
	     {
            displayTemp = 1;
	     }


         else if (displayBattery == 1 && displayTime == 1 && displayTemp == 1)
	     {
            displayTemp = 0;
            displayBattery = 0;
            displayTime = 0;
	     }



         else
	     {
            displayTemp = 0;
            displayBattery = 1;
            displayTime = 0;
	     }



	    blit_messageGame("->",300);
	 }



    if (pad.Buttons & PSP_CTRL_SCREEN)
    {

        if (pad.Buttons & PSP_CTRL_RTRIGGER)
        {

            if(screenshotname_c < 10)
				sprintf(screenshotname,"ms0:/PICTURE/screenshotGAME (%d).bmp",screenshotname_c);
			else
				sprintf(screenshotname,"ms0:/PICTURE/screenshotGAME (%d).bmp",screenshotname_c);


			while((screenshot_file = fopen(screenshotname,"r")) != NULL)
			{
				if(screenshotname_c < 10)
					sprintf(screenshotname,"ms0:/PICTURE/screenshotGAME (%d).bmp",screenshotname_c);
				else
					sprintf(screenshotname,"ms0:/PICTURE/screenshotGAME (%d).bmp",screenshotname_c);
				screenshotname_c++;
				fclose(screenshot_file);
			}

                sceKernelDelayThread(1000);

                screenshot(screenshotname);
                sceKernelDelayThread(1000000);

        }





        if (pad.Buttons & PSP_CTRL_LTRIGGER)
        {

            nkThreadSuspend(sceKernelGetThreadId());
            pspDebugScreenEnableBackColor(1);


            while(1)
			{

			    sceCtrlReadBufferPositive(&pad,1);

                blit_messageGameXY(18,18,"BREAK  Presse START to resume",100);


				if(pad.Buttons & PSP_CTRL_START)
				{

				    sceKernelDelayThread(300000);
				    nkThreadResume(sceKernelGetThreadId());
				    pspDebugScreenEnableBackColor(0);
					break;
				}

                sceKernelDelayThread(3000);
			}
        }

    }



/*
if(pad.Buttons & PSP_CTRL_VOLDOWN)
{
sceKernelExitGame();
}
*/

if(pad.Buttons & PSP_CTRL_VOLUP)

{


    //POWER Lock-->>
	if (pad.Buttons & PSP_CTRL_LTRIGGER)
	 {
        lockPower();
	 }


    //DEL-->>
    if (pad.Buttons & PSP_CTRL_RTRIGGER)
	 {
        ledP();
	 }



    //Brightness-->>
    if (pad.Buttons & PSP_CTRL_UP)
	 {
        SetBrightnessM(+10);

        sprintf(&brightnessP, "Brightness + 10  --> %d", curBrightness);

        blit_messageGame(&brightnessP,300);
	 }

    if (pad.Buttons & PSP_CTRL_DOWN)
	 {
	     SetBrightnessM(-10);

	     sprintf(&brightnessP, "Brightness - 10  --> %d", curBrightness);

	     blit_messageGame(&brightnessP,300);
	 }

    if (pad.Buttons & PSP_CTRL_RIGHT)
	 {
			SetBrightnessM(102);
	 }

    if (pad.Buttons & PSP_CTRL_LEFT)
	 {
        SetBrightnessM(101);
	 }

}



    //Si tu mets la ligne suivante,le texte scintillera mais le xmb ne se figera pas.
      sceKernelDelayThread(3000);
   }

   return 0;

}





//point d'entree
int module_start(SceSize args, void *argp)
{
   //cree le thread principal
   SceUID thid = sceKernelCreateThread("main_thread", main_thread, 25, 64*1024, 0, NULL);

   if(thid >= 0)

   {
      //charge le thread principal

      sceKernelStartThread(thid, args, argp);

      nkLoad();

   }
   //ici vous pouvez creer un thread pour l'affichage si vous en avez besoin
   return 0;
}

int module_stop(SceSize args, void *argp)
{
   return 0;
}


void pause(int time_in_ms)
{
	int i;
	for(i = 0;i < time_in_ms;i++)
	{
		sceKernelDelayThread(1000);
	}
}

void blit_string(int x,int y,char* str,u32 color)
{
	int oldx = pspDebugScreenGetX();
	int oldy = pspDebugScreenGetY();
	pspDebugScreenSetXY(x,y);
	pspDebugScreenSetTextColor(color);
	pspDebugScreenSetXY(oldx,oldy);
	pspDebugScreenSetTextColor(white);
}

void SetBrightnessM(int mode)
{
    sceDisplayGetBrightness(&curBrightness, 0);


    if (mode == 102)
    {
            sceDisplaySetBrightness(99,0);
			blit_messageGame("Brightness MAX",1000);
    }

    if (mode == 101)
    {
            blit_messageGame("Brightness MIN",500);
			sceDisplaySetBrightness(1,0);
    }
    else
    {
        curBrightness = curBrightness + mode;

        if (curBrightness >= 100)
        {
            curBrightness=100;
        }


        if (curBrightness <= 0)
        {
            curBrightness=0;
        }

        sceDisplaySetBrightness(curBrightness,0);
    }
}


//-------
int build_args(char *args, const char *execfile, int argc, char **argv)
{
	int loc = 0;
	int i;

	strcpy(args, execfile);
	loc += strlen(execfile) + 1;
	for(i = 0; i < argc; i++)
	{
		strcpy(&args[loc], argv[i]);
		loc += strlen(argv[i]) + 1;
	}

	return loc;
}

//execute un fichier prx
int loadStartModule(const char *name, int argc, char **argv)
{
	SceUID modid;
	int status;
	char args[1024];
	int len;

	modid = sceKernelLoadModule(name, 0, NULL);
	if(modid >= 0)
	{
		len = build_args(args, name, argc, argv);
		modid = sceKernelStartModule(modid, len, (void *) args, &status, NULL);
	}
	else
	{
		printf("lsm: Error loading module %s\n", name);
	}

	return modid;
}

//execute un eboot
void execEboot(char* buf)
{
	SceUID eboot_file;
	if((eboot_file = sceIoOpen(buf,PSP_O_RDONLY,0777)) >= 0)
	{
		sceIoClose(eboot_file);
		struct SceKernelLoadExecVSHParam param;
		memset(&param, 0, sizeof(param));
   		param.key = "game";
   		param.size = sizeof(param);
   		param.args = strlen(buf)+1;
   		param.argp = buf;
		if(sceKernelLoadExecVSHMs2(buf, &param) < 0)
			sceKernelLoadExecVSHMs4(buf, &param);
	}
}


//Function lockPower-->>
void lockPower()
{
		if (powerLocked == 0) {

		    if (scePowerLock(0) == 0)
		    {
			powerLocked = 1;

			blit_messageGame("Power locked",1000);
		    }
		    else
			blit_messageGame("Error locking power switch",1000);

		} else {

		    if (scePowerUnlock(0) == 0)
		    {
			powerLocked = 0;

			blit_messageGame("Power unlocked",1000);
		    }
		    else
		    blit_messageGame("Error unlocking power switch",1000);
		}
}

//Function DEL Active/Unactive-->>
void ledP()

{

    if(led_state == STATE_ON)
        {

        blit_messageGame("Power led OFF",1000);

        sceSysconCtrlLED(POWER_LED,STATE_OFF);
        led_state = STATE_OFF;
        }
    else
        {

        blit_messageGame("Power led ON",1000);

        sceSysconCtrlLED(POWER_LED,STATE_ON);
        led_state = STATE_ON;
        }

}






static u32 adjust_alpha(u32 col)
{
	u32 alpha = col>>24;
	u8 mul;
	u32 c1,c2;

	if(alpha==0)    return col;
	if(alpha==0xff) return col;

	c1 = col & 0x00ff00ff;
	c2 = col & 0x0000ff00;
	mul = (u8)(255-alpha);
	c1 = ((c1*mul)>>8)&0x00ff00ff;
	c2 = ((c2*mul)>>8)&0x0000ff00;
	return (alpha<<24)|c1|c2;
}

//afficher un message a l'ecran pendant time_in_ms millisecondes
void blit_messageGame(char* message,int time_in_ms)
{
	int i;
	for(i = 0;i < time_in_ms;i++)
	{
		blit_prx(25,0,message,0xFFFFFF,0xFF000000);
		sceKernelDelayThread(1000);
	}
}



int blit_prx(int sx,int sy,const char *msg,int fg_col,int bg_col)
{
	int x,y,p;
	int offset;
	char code;
	unsigned char font;

	u32 col,c1,c2;
	u32 alpha;

	fg_col = adjust_alpha(fcolor);
	bg_col = adjust_alpha(bcolor);

	int pwidth, pheight, bufferwidth, pixelformat, unk, ret;
	unsigned int* vram32;
   	sceDisplayGetMode(&unk, &pwidth, &pheight);
   	sceDisplayGetFrameBuf((void*)&vram32, &bufferwidth, &pixelformat, &unk);

    if(bufferwidth == 0)
        return;
    if(pixelformat != 3)//this has problems when pixel format == 3 (in gta vcs anyway)
    {
        pspDebugScreenSetColorMode(pixelformat);
        pspDebugScreenSetOffset(0);
        pspDebugScreenSetBase(0x44000000);

        pspDebugScreenSetBackColor(bg_col);
        pspDebugScreenSetTextColor(fg_col);
        pspDebugScreenSetXY(sx,sy);
        return pspDebugScreenPuts(msg);
     }
     else
     {
        sy*=8;
    	for(x=0;msg[x] && x<(pwidth/8);x++)
    	{
    		code = msg[x] & 0x7f; // 7bit ANK
    		for(y=0;y<7;y++)
    		{
    			offset = (sy+y)*bufferwidth + (sx+x)*8;
    			font = msx[ code*8 + y ];
    			for(p=0;p<8;p++)
    			{

					col = (font & 0x80) ? fg_col : bg_col;
					alpha = col>>24;
					if(alpha==0) vram32[offset] = col;
					else if(alpha!=0xff)
					{
						c2 = vram32[offset];
						c1 = c2 & 0x00ff00ff;
						c2 = c2 & 0x0000ff00;
						c1 = ((c1*alpha)>>8)&0x00ff00ff;
						c2 = ((c2*alpha)>>8)&0x0000ff00;
						vram32[offset] = (col&0xffffff) + c1 + c2;
					}
					else
					{
						vram32[offset] = (font & 0x80) ? fg_col : bg_col;
					}

    				font <<= 1;
    				offset++;
    			}
    		}
    	}
    	return x;
    }
}



void blit_messageGameXY (int X,int Y,char* message,int time_in_ms)
{
	int i;
	for(i = 0;i < time_in_ms;i++)
	{
		blit_prx(X,Y,message,0xFFFFFF,0xFF000000);
		sceKernelDelayThread(1000);
	}
}

void printInBreak(int X, int Y, char* message, int time_in_ms)
{

            nkThreadSuspend(sceKernelGetThreadId());
            pspDebugScreenEnableBackColor(1);


            blit_messageGameXY(X,Y,message,time_in_ms);

            pspDebugScreenEnableBackColor(0);
            nkThreadResume(sceKernelGetThreadId());

}
