/*
PSPluginInfo - By Mickael2054
*/

//Add LIB-->>
#include <pspkernel.h>
#include <pspdebug.h>
#include <psppower.h>
#include <pspctrl.h>
#include <pspmoduleinfo.h>
#include <pspwlan.h>
#include <stdio.h>
#include <pspdisplay.h>
#include <psprtc.h>
#include <systemctrl.h>
#include <string.h>
#include <pspumd.h>
#include <psploadexec_kernel.h>
#include <pspusb.h>
#include <pspusbstor.h>

#include <pspiofilemgr.h>
#include <stdlib.h>

#include "screenshot.h"


//define-->>

//DISPLAY
#define printf	pspDebugScreenPrintf

//COLORS
#define RGB(r, g, b) ((r)|((g)<<8)|((b)<<16))

//POWER DEL-->>
#define POWER_LED 2
#define STATE_ON 1
#define STATE_OFF 0

//PAD-->>
#define PSP_CTRL_VOLUP 0x100000
#define PSP_CTRL_VOLDOWN 0x200000
#define PSP_CTRL_HOME 0x010000
#define PSP_CTRL_HOLD 0x020000
#define PSP_CTRL_NOTE 0x800000
#define PSP_CTRL_SCREEN 0x400000
#define PSP_CTRL_WLAN_UP 0x040000
#define PSP_CTRL_REMOTE 0x080000
#define PSP_CTRL_DISC 0x1000000
#define PSP_CTRL_MS 0x2000000

#define GAME_PATH_DEST  "disc0:/PSP_GAME/SYSDIR/BOOT.BIN"


//0x1000 = kernel mode
PSP_MODULE_INFO("PSPluginInfo", 0x1000, 1, 1);


int batteryLifeTime = 0;
int powerLocked = 0;
int powerTicks = 0;

//COLORS
int white = RGB(255, 255, 255);
int black = RGB(0, 0, 0);
int blue = RGB(0, 0, 255);
int red = RGB(255, 0, 0);


int led_state = STATE_ON;

int UMD;

int curBrightness = 50;
char brightnessP;

int dispTempXMBOk = 0;
int dispperBattXMBOk = 1;
int dispWarnMessXMBOk = 1;

int hookfunctions = 1;

int customLightLevels = 0;

int stat=0;

int tpsCamConnect = 0;

int configSelecteur = 1;

int loopBright = "up";

char screenshotname[30];
int screenshotname_c = 1;

FILE* screenshot_file = NULL;


//Brightness--------------->>
void sceDisplay_driver_9E3C6DC6(int a0,int a1);//a0 0-100,a1 = 0/1 (set to 0)
#define sceDisplaySetBrightness sceDisplay_driver_9E3C6DC6
void sceDisplay_driver_31C4BAA8(int *a0,int *a1);
#define sceDisplayGetBrightness sceDisplay_driver_31C4BAA8
int sceDisplayEnable(void);
int sceDisplayDisable(void);
//------------------
void pause(int time_in_ms);
void blit_string(int x,int y,char* str,u32 color);
void blit_message(char* message,int time_in_ms);
void SetBrightnessM(int mode);
int umdInfo();
int build_args(char *args, const char *execfile, int argc, char **argv);
int loadStartModule(const char *name, int argc, char **argv);
void execEboot(char* buf);
//int (*vshCtrlReadBufferPositive)(SceCtrlData* pad_data,int count);
//int vshCtrlReadBufferPositive_patch(SceCtrlData* pad_data,int count);
//void vsh_pad();
void lockPower();
void ledP();
void LaunchUMD();
void autoboot();
void hookxmbf();
void setupUsb();
int getMSfreeSpace();
void Pause23(int atemp);


////////////////77
extern u8 msx[];
static u32 fcolor = 0x00ffffff;
static u32 bcolor = 0xff000000;




static u32 adjust_alpha(u32 col);

/////////////////7

void infoPAD()
{
    //VOL- and START
    SceCtrlData pad;

nkThreadSuspend(sceKernelGetThreadId());//-------------------

    while(1)
        {
        sceCtrlReadBufferPositive(&pad,1);


    pspDebugScreenSetXY(0,4);


	printf("   PSPluginInfo V0.7 - By Mickael2054 - Big Thanks to AntoineDravs!\n");
	printf("   -----------------------------------------------------------------\n");


    printf("VOL+ and START --> Info menu\n");
    printf("VOL+ and L --> Power switch lock/unlock\n");
    printf("VOL+ and R --> Power DEL ON/OFF\n");
    printf("VOL+ and UP --> Brightness + 10\n");
    printf("VOL+ and DOWN --> Brightness - 10\n");
    printf("VOL+ and LEFT --> Brightness MIN\n");
    printf("VOL+ and RIGHT --> Brightness MAX\n");
    printf("VOL+ and SQUARE --> Load UMD\n");
    //printf("VOL+ and SCREEN --> Launch recovery\n\n");
    printf("VOL+ and HOME --> Config menu\n\n");

    printf("VOL- and VOL+ --> Restart the PSP\n");
    printf("VOL- and SELECT --> Launch ms0:/PSP/PSPluginInfoPRX/EBOOT.PBP\n\n");

    printf("SCREEN and L --> Active/Unactive USB\n");
    printf("SCREEN and R --> Take screenshot (ms0:/PICTURE)\n\n");

    printf("R and function --> Hook this function\n\n");

    printf("L in start --> autoboot ms0:/PSP/PSPluginInfoPRX/AUTOBOOT/EBOOT.PBP\n\n");



    printf("\n                             CIRCLE --> EXIT");


    if(pad.Buttons & PSP_CTRL_CIRCLE)
        {
            nkThreadResume(sceKernelGetThreadId());//-----------------

            break;
        }

            //sceKernelDelayThread(3000);
        }
}


void choice()
{

    SceCtrlData pad;

        while(1)
			{
            sceCtrlReadBufferPositive(&pad,1);


            pspDebugScreenSetXY(0,6);

            pspDebugScreenSetTextColor(red);


		    printf("  ---------------------------Config VSH---------------------------\n\n\n");

            if (configSelecteur == 1)
            {

            printf("-> Display percent of battery in XMB: %s\n\n", dispperBattXMBOk == 0 ? "No":"Yes");
            printf("   Display temperature in XMB: %s\n\n", dispTempXMBOk == 0 ? "No":"Yes");
            printf("   Display warning message in XMB: %s\n\n", dispWarnMessXMBOk == 0 ? "No":"Yes");
            printf("   Active hook functions (R): %s\n\n", hookfunctions == 0 ? "No":"Yes");
            printf("   Use custom brightness levels: %s\n\n", customLightLevels == 0 ? "No":"Yes");

                    if (pad.Buttons & PSP_CTRL_RIGHT)
                        {
                            dispperBattXMBOk = 0;
                        }

                    if (pad.Buttons & PSP_CTRL_LEFT)
                        {
                            dispperBattXMBOk = 1;
                        }

            }

            if (configSelecteur == 2)
            {

            printf("   Display percent of battery in XMB: %s\n\n", dispperBattXMBOk == 0 ? "No":"Yes");
            printf("-> Display temperature in XMB: %s\n\n", dispTempXMBOk == 0 ? "No":"Yes");
            printf("   Display warning message in XMB: %s\n\n", dispWarnMessXMBOk == 0 ? "No":"Yes");
            printf("   Active hook functions (R): %s\n\n", hookfunctions == 0 ? "No":"Yes");
            printf("   Use custom brightness levels: %s\n\n", customLightLevels == 0 ? "No":"Yes");


                    if (pad.Buttons & PSP_CTRL_RIGHT)
                        {
                            dispTempXMBOk = 0;
                        }

                    if (pad.Buttons & PSP_CTRL_LEFT)
                        {
                            dispTempXMBOk = 1;
                        }

            }

            if (configSelecteur == 3)
            {

            printf("   Display percent of battery in XMB: %s\n\n", dispperBattXMBOk == 0 ? "No":"Yes");
            printf("   Display temperature in XMB: %s\n\n", dispTempXMBOk == 0 ? "No":"Yes");
            printf("-> Display warning message in XMB: %s\n\n", dispWarnMessXMBOk == 0 ? "No":"Yes");
            printf("   Active hook functions (R): %s\n\n", hookfunctions == 0 ? "No":"Yes");
            printf("   Use custom brightness levels: %s\n\n", customLightLevels == 0 ? "No":"Yes");

                    if (pad.Buttons & PSP_CTRL_RIGHT)
                        {
                            dispWarnMessXMBOk = 0;
                        }

                    if (pad.Buttons & PSP_CTRL_LEFT)
                        {
                            dispWarnMessXMBOk = 1;
                        }

            }


            if (configSelecteur == 4)
            {

            printf("   Display percent of battery in XMB: %s\n\n", dispperBattXMBOk == 0 ? "No":"Yes");
            printf("   Display temperature in XMB: %s\n\n", dispTempXMBOk == 0 ? "No":"Yes");
            printf("   Display warning message in XMB: %s\n\n", dispWarnMessXMBOk == 0 ? "No":"Yes");
            printf("-> Active hook functions (R): %s\n\n", hookfunctions == 0 ? "No":"Yes");
            printf("   Use custom brightness levels: %s\n\n", customLightLevels == 0 ? "No":"Yes");

                    if (pad.Buttons & PSP_CTRL_RIGHT)
                        {
                            hookfunctions = 0;
                        }

                    if (pad.Buttons & PSP_CTRL_LEFT)
                        {
                            hookfunctions = 1;
                        }

            }



            if (configSelecteur == 5)
            {

            printf("   Display percent of battery in XMB: %s\n\n", dispperBattXMBOk == 0 ? "No":"Yes");
            printf("   Display temperature in XMB: %s\n\n", dispTempXMBOk == 0 ? "No":"Yes");
            printf("   Display warning message in XMB: %s\n\n", dispWarnMessXMBOk == 0 ? "No":"Yes");
            printf("   Active hook functions (R): %s\n\n", hookfunctions == 0 ? "No":"Yes");
            printf("-> Use custom brightness levels: %s\n\n", customLightLevels == 0 ? "No":"Yes");

                    if (pad.Buttons & PSP_CTRL_RIGHT)
                        {
                            customLightLevels = 0;
                        }

                    if (pad.Buttons & PSP_CTRL_LEFT)
                        {
                            customLightLevels = 1;
                        }

            }



            if (pad.Buttons & PSP_CTRL_UP && configSelecteur > 1)
            {
            configSelecteur--;
            Pause23(4000);
            }

            if (pad.Buttons & PSP_CTRL_DOWN && configSelecteur < 5)
            {
            configSelecteur++;
            Pause23(4000);
            }


            printf("\n\n\n\n\n                            CIRCLE --> EXIT");


                if(pad.Buttons & PSP_CTRL_CIRCLE)
                    {
                        pspDebugScreenSetTextColor(white);
                        break;
                    }


            }
}


//function infoMenu-->>
void infoMenu()
{
    //VOL+ and START


SceCtrlData pad;


    while(1)
    {

        sceCtrlPeekBufferPositive(&pad,1);


        pspDebugScreenSetXY(0,4);

        //info sur le systeme
        printf("External Power: %s\n", scePowerIsPowerOnline()? "yes" : "no ");
        printf("Battery: %s\n", scePowerIsBatteryExist()? "present" : "absent ");

        if (scePowerIsBatteryExist()) {
            printf("Low Charge: %s\n", scePowerIsLowBattery()? "yes" : "no ");
            printf("Charging: %s\n", scePowerIsBatteryCharging()? "yes" : "no ");
            printf("Charge %d%% (%02dh%02dm)     \n", scePowerGetBatteryLifePercent(), batteryLifeTime/60, batteryLifeTime-(batteryLifeTime/60*60));
            printf("Volts: %imV\n",scePowerGetBatteryVolt());
            printf("Battery Temp: %d deg C\n", scePowerGetBatteryTemp());
        } else
            printf("Battery stats unavailable\n");


        printf("\n\nCPU Speed: %d mHz\n", scePowerGetCpuClockFrequency());
        printf("Bus Speed: %d mHz\n", scePowerGetBusClockFrequency());
        printf("Power Switch: %s\n", powerLocked == 0 ? "unlocked" : "locked");


        printf("\n\nWlan switch: %s\n", sceWlanGetSwitchState() == 0 ? "off":"on");
        printf("Wlan power: %s\n", sceWlanDevIsPowerOn() == 0 ? "off":"on");


        printf("\n\nMS free space : %d Mo", getMSfreeSpace()/1048576);


        printf("\n\nUMD: %s\n\n", umdInfo() == 0 ? "absent":"present");


    unsigned char Mac [512];
    sceWlanGetEtherAddr(Mac);

        printf ("\nMAC Address: %02X: %02X: %02X: %02X: %02X: %02X\n",Mac[0], Mac [1], Mac [2], Mac [3], Mac [4], Mac [5]);




    pspTime psptime;
    sceRtcGetCurrentClockLocalTime(&psptime);

    printf("\n%02u/%02u/%02u - %02u:%02u:%02u", psptime.day, psptime.month, psptime.year, psptime.hour, psptime.minutes, psptime.seconds);

    printf("\n\n                            CIRCLE --> EXIT");


        if(pad.Buttons & PSP_CTRL_CIRCLE)
            {
                break;
            }

    sceKernelDelayThread(3000);
    }

}


int unloadStopModule(char *modname)
{
	SceModule *mod;

	while ((mod = sceKernelFindModuleByName(modname)))
	{
		sceKernelStopModule(mod->modid, 0, NULL, NULL, NULL);
		sceKernelUnloadModule(mod->modid);
	}

	return 0;

}


//////////////////////////////////////////////////////////////////////

//main thread-->>
int main_thread(SceSize args, void *argp)
{

SceCtrlData pad;

   //initialise l'ecran
   pspDebugScreenInit();

   //desactive l'arriere plan
   pspDebugScreenEnableBackColor(0);

   //attend que le xmb se charge
   sceKernelDelayThread(3000000);

autoboot();

    	sceCtrlPeekBufferPositive(&pad, 1);

   while(1)
   {

      batteryLifeTime = scePowerGetBatteryLifeTime();


      //Debug screen
      pspDebugScreenSetXY(0,0);

      //Blit battery % and time
      if (dispperBattXMBOk == 1)
      {
      printf("%d%% (%02dh %02dm)\n", scePowerGetBatteryLifePercent(), batteryLifeTime/60, batteryLifeTime-(batteryLifeTime/60*60));
      }

      if (dispTempXMBOk == 1)
      {
      printf("%d deg C\n", scePowerGetBatteryTemp());
      }


      /*  if(sceKernelFindModuleByName("SceUsbstor"))
        {
            printf("\n\nMS free space : %d Mo", getMSfreeSpace()/1048576);
        }
*/


      // If battery is low-->>
    if (scePowerGetBatteryLifePercent() < 10 && scePowerIsPowerOnline()!= 1 && dispWarnMessXMBOk == 1)

    {
        pspDebugScreenEnableBackColor(1);
        pspDebugScreenSetXY(17,29);
        printf("WARNING your battery is low! (%d%%)", scePowerGetBatteryLifePercent());
        pspDebugScreenEnableBackColor(0);
    }



    if (sceKernelFindModuleByName("camera_plugin_module"))
        tpsCamConnect++;

    else
        tpsCamConnect=0;


//PAD IN XMB----------------------------------------------->
sceCtrlPeekBufferPositive(&pad, 1);

    if (hookfunctions == 1 && pad.Buttons & PSP_CTRL_RTRIGGER && tpsCamConnect < 500)
    {
        hookxmbf();
    }


    if (pad.Buttons & PSP_CTRL_SCREEN)
    {

        if (pad.Buttons & PSP_CTRL_LTRIGGER)
        {

            if (stat == 0)
            {
                    setupUsb();

                    sceUsbActivate(0x1c8);//On active L'usb
                    blit_message("USB Activer",1200);
                    stat=1;
            }
            else
            {
                    sceUsbDeactivate(0x1c8);//On Desactive L'usb

                    sceUsbStop(PSP_USBSTOR_DRIVERNAME, 0, 0); //sceUsbStop
                    sceUsbStop(PSP_USBBUS_DRIVERNAME, 0, 0);

                    ////////////////////7
                    unloadStopModule("semawm");
                    unloadStopModule("usbstor");
                    unloadStopModule("usbstormgr");
                    unloadStopModule("usbstorms");
                    unloadStopModule("usbstorboot");
                    //////////////////7

                    blit_message("USB Desactiver",1200);
                    stat=0;
            }

            sceKernelDelayThread(100000);
        }



        else if (pad.Buttons & PSP_CTRL_RTRIGGER)
        {


            if(screenshotname_c < 10)
				sprintf(screenshotname,"ms0:/PICTURE/screenshotXMB (%d).bmp",screenshotname_c);
			else
				sprintf(screenshotname,"ms0:/PICTURE/screenshotXMB (%d).bmp",screenshotname_c);


			while((screenshot_file = fopen(screenshotname,"r")) != NULL)
			{
				if(screenshotname_c < 10)
					sprintf(screenshotname,"ms0:/PICTURE/screenshotXMB (%d).bmp",screenshotname_c);
				else
					sprintf(screenshotname,"ms0:/PICTURE/screenshotXMB (%d).bmp",screenshotname_c);
				screenshotname_c++;
				fclose(screenshot_file);
			}



                sceKernelDelayThread(1000);


                screenshot(screenshotname);
                sceKernelDelayThread(1000000);

        }

        else
        {

            if (customLightLevels == 1)
            {

                sceCtrlReadBufferPositive(&pad, 1);

                if (curBrightness > 97)
                        loopBright = "down";
                else if (curBrightness < 3)
                        loopBright = "up";

                if (loopBright == "up")
                    SetBrightnessM(+1);
                else
                    SetBrightnessM(-1);
            }

        }
    }



sceCtrlPeekBufferPositive(&pad, 1);
if(pad.Buttons & PSP_CTRL_VOLDOWN)
{

    if(pad.Buttons & PSP_CTRL_START)
		{
		    infoPAD();
		}


		if(pad.Buttons & PSP_CTRL_SELECT)
		{
		execEboot("ms0:/PSP/PSPluginInfoPRX/EBOOT.PBP");
		}

}


if(pad.Buttons & PSP_CTRL_VOLUP)

{

    if(pad.Buttons & PSP_CTRL_START)
    {
        infoMenu();
    }




    //POWER Lock-->>
	if (pad.Buttons & PSP_CTRL_LTRIGGER)
	 {
        lockPower();
	 }


    //DEL-->>
    if (pad.Buttons & PSP_CTRL_RTRIGGER)
	 {
        ledP();
	 }



    //Brightness-->>
    if (pad.Buttons & PSP_CTRL_UP)
	 {
        SetBrightnessM(+10);

        sprintf(&brightnessP, "Brightness + 10  --> %d", curBrightness);

        blit_message(&brightnessP,300);
	 }

    if (pad.Buttons & PSP_CTRL_DOWN)
	 {
	     SetBrightnessM(-10);

	     sprintf(&brightnessP, "Brightness - 10  --> %d", curBrightness);

	     blit_message(&brightnessP,300);
	 }

    if (pad.Buttons & PSP_CTRL_RIGHT)
	 {
			SetBrightnessM(102);
	 }

    if (pad.Buttons & PSP_CTRL_LEFT)
	 {
        SetBrightnessM(101);
	 }



    if (pad.Buttons & PSP_CTRL_SQUARE)
	 {
        blit_message("Start UMD",800);
        LaunchUMD();
	 }




    if(pad.Buttons & PSP_CTRL_HOME)
    {
        choice();
    }



        /*if(pad.Buttons & PSP_CTRL_NOTE)
		{
		    loadStartModule("ms0:/recovery.prx",0,NULL);
            nkThreadSuspend(sceKernelGetThreadId());//-------------------
		}
		*/


        if(pad.Buttons & PSP_CTRL_VOLDOWN)
		{
        scePower_driver_0442D852();
		}

}

    //Si tu mets la ligne suivante,le texte scintillera mais le xmb ne se figera pas.
      sceKernelDelayThread(3000);
   }

   return 0;

}





//point d'entree
int module_start(SceSize args, void *argp)
{
   //cree le thread principal
   SceUID thid = sceKernelCreateThread("main_thread", main_thread, 25, 64*1024, 0, NULL);

   if(thid >= 0)

   {
      //charge le thread principal

      sceKernelStartThread(thid, args, argp);

      nkLoad();

   }
   //ici vous pouvez creer un thread pour l'affichage si vous en avez besoin
   return 0;
}

int module_stop(SceSize args, void *argp)
{
   return 0;
}


void pause(int time_in_ms)
{
	int i;
	for(i = 0;i < time_in_ms;i++)
	{
		sceKernelDelayThread(1000);
	}
}

void blit_string(int x,int y,char* str,u32 color)
{
	int oldx = pspDebugScreenGetX();
	int oldy = pspDebugScreenGetY();
	pspDebugScreenSetXY(x,y);
	pspDebugScreenSetTextColor(color);
	pspDebugScreenSetXY(oldx,oldy);
	pspDebugScreenSetTextColor(white);
}

void blit_message(char* message,int time_in_ms)
{
	int i;
	for(i = 0;i < time_in_ms;i++)
	{

		pspDebugScreenSetXY(25,0);

		 pspDebugScreenSetTextColor(blue);

		pspDebugScreenPrintf(message);
		sceKernelDelayThread(1000);

		pspDebugScreenSetTextColor(white);
	}
}

void SetBrightnessM(int mode)
{
    sceDisplayGetBrightness(&curBrightness, 0);


    if (mode == 102)
    {
            sceDisplaySetBrightness(99,0);
			blit_message("Brightness MAX",1000);
    }

    if (mode == 101)
    {
            blit_message("Brightness MIN",500);
			sceDisplaySetBrightness(1,0);
    }
    else
    {
        curBrightness = curBrightness + mode;

        if (curBrightness >= 100)
        {
            curBrightness=100;
        }


        if (curBrightness <= 0)
        {
            curBrightness=0;
        }

        sceDisplaySetBrightness(curBrightness,0);
    }
}

int umdInfo()
{

    SceCtrlData pad;
    sceCtrlPeekBufferPositive(&pad, 1);


    if (pad.Buttons & PSP_CTRL_DISC)
    {
        UMD = 1;
    }
    else
    {
        UMD = 0;
    }

    return UMD;
}

//-------
int build_args(char *args, const char *execfile, int argc, char **argv)
{
	int loc = 0;
	int i;

	strcpy(args, execfile);
	loc += strlen(execfile) + 1;
	for(i = 0; i < argc; i++)
	{
		strcpy(&args[loc], argv[i]);
		loc += strlen(argv[i]) + 1;
	}

	return loc;
}

//execute un fichier prx
int loadStartModule(const char *name, int argc, char **argv)
{
	SceUID modid;
	int status;
	char args[1024];
	int len;

	modid = sceKernelLoadModule(name, 0, NULL);
	if(modid >= 0)
	{
		len = build_args(args, name, argc, argv);
		modid = sceKernelStartModule(modid, len, (void *) args, &status, NULL);
	}
	else
	{
		printf("lsm: Error loading module %s\n", name);
	}

	return modid;
}

//execute un eboot
void execEboot(char* buf)
{
	SceUID eboot_file;
	if((eboot_file = sceIoOpen(buf,PSP_O_RDONLY,0777)) >= 0)
	{
		sceIoClose(eboot_file);
		struct SceKernelLoadExecVSHParam param;
		memset(&param, 0, sizeof(param));
   		param.key = "game";
   		param.size = sizeof(param);
   		param.args = strlen(buf)+1;
   		param.argp = buf;
		if(sceKernelLoadExecVSHMs2(buf, &param) < 0)
			sceKernelLoadExecVSHMs4(buf, &param);
	}
}

/*
//--------------------------------------------------------------------
//hook la fonction vshCtrlReadBufferPositive pour que le joystick puisse controler le xmb
int (*vshCtrlReadBufferPositive)(SceCtrlData* pad_data,int count);

int vshCtrlReadBufferPositive_patch(SceCtrlData* pad_data,int count)
{
	int ret = vshCtrlReadBufferPositive(pad_data,count);
	int interrupts = pspSdkDisableInterrupts();
       //Verifie si on n'est pas dans le navigateur
	if(!sceKernelFindModuleByName("htmlviewer_plugin_module"))
	{
               //convertit les mouvements du joystick en appui du pad analogique
		sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
		if(pad_data->Lx == 0)
			pad_data->Buttons |= PSP_CTRL_LEFT;
		if(pad_data->Lx == 255)
			pad_data->Buttons |= PSP_CTRL_RIGHT;
		if(pad_data->Ly == 0)
			pad_data->Buttons |= PSP_CTRL_UP;
		if(pad_data->Ly == 255)
			pad_data->Buttons |= PSP_CTRL_DOWN;
	}
	pspSdkEnableInterrupts(interrupts);
	return ret;
}

void vsh_pad()
{
       //la fonction se trouve dans le module sceVshBridge_Driver dans la lib sceVshBridge au nid 0xC6395C03
	u32 orgaddr = sctrlHENFindFunction("sceVshBridge_Driver","sceVshBridge",0xC6395C03);
	vshCtrlReadBufferPositive = (void*)orgaddr;
	sctrlHENPatchSyscall(orgaddr,vshCtrlReadBufferPositive_patch);
	sceKernelDcacheWritebackAll();
	sceKernelIcacheClearAll();
}
//--------------------------------------------------------------------
*/

//Function lockPower-->>
void lockPower()
{
		if (powerLocked == 0) {

		    if (scePowerLock(0) == 0)
		    {
			powerLocked = 1;

			blit_message("Power locked",1000);
		    }
		    else
			printf("Error locking power switch\n");

		} else {

		    if (scePowerUnlock(0) == 0)
		    {
			powerLocked = 0;

			blit_message("Power unlocked",1000);
		    }
		    else
			printf("Error unlocking power switch\n");
		}
}

//Function DEL Active/Unactive-->>
void ledP()

{

    if(led_state == STATE_ON)
        {

        blit_message("Power led OFF",1000);

        sceSysconCtrlLED(POWER_LED,STATE_OFF);
        led_state = STATE_OFF;
        }
    else
        {

        blit_message("Power led ON",1000);

        sceSysconCtrlLED(POWER_LED,STATE_ON);
        led_state = STATE_ON;
        }

}


void LaunchUMD()
{

/*
//Testing if UMD is present...
int i;
i = sceUmdCheckMedium(0);
if(i == 0){
//no disc, wait for insert
blit_message("No UMD! Please insert the UMD",500);
sceUmdWaitDriveStat(UMD_WAITFORDISC);
}
//Mount UMD
sceUmdActivate(1, "disc0:");
sceUmdWaitDriveStat(UMD_WAITFORINIT);
//Start main executable
sceKernelLoadExec("disc0:/PSP_GAME/SYSDIR/BOOT.BIN", 0);
*/


//Testing if UMD is present...
    if(sceUmdCheckMedium(0) == 0){
        //no disc, wait for insert
        blit_message("No UMD",2000);
    }
    else
    {

        struct SceKernelLoadExecVSHParam param;

        memset(&param, 0, sizeof(param));
        param.size = sizeof(param);
        param.args = strlen("disc0:/PSP_GAME/SYSDIR/EBOOT.BIN")+ 1;
        param.argp = "disc0:/PSP_GAME/SYSDIR/EBOOT.BIN";
        param.key = "game";


        sctrlKernelLoadExecVSHDisc("disc0:/PSP_GAME/SYSDIR/EBOOT.BIN", &param);
    }
}

void autoboot()
{

SceCtrlData pad;
sceCtrlPeekBufferPositive(&pad,1);

if(pad.Buttons & PSP_CTRL_LTRIGGER)
{
execEboot("ms0:/PSP/PSPluginInfoPRX/AUTOBOOT/EBOOT.PBP");
}
}


void hookxmbf()
{

	if(sceKernelFindModuleByName("lftv_plugin_module"))
	{
	    blit_message("HOOK --> RUN",400);
		execEboot("ms0:/PSP/PSPluginInfoPRX/lftv/EBOOT.PBP");
	}
	if(sceKernelFindModuleByName("premo_plugin_module"))
	{
	    blit_message("HOOK --> RUN",400);
		execEboot("ms0:/PSP/PSPluginInfoPRX/remoteplay/EBOOT.PBP");
	}
	if(sceKernelFindModuleByName("rss_main_plugin_module"))
	{
	    blit_message("HOOK --> RUN",400);
		execEboot("ms0:/PSP/PSPluginInfoPRX/rss/EBOOT.PBP");
	}
	if(sceKernelFindModuleByName("sceVshGSPlugin_Module"))
	{
	    blit_message("HOOK --> RUN",400);
		execEboot("ms0:/PSP/PSPluginInfoPRX/gamesharing/EBOOT.PBP");
	}
	if(sceKernelFindModuleByName("update_plugin_module"))
	{
	    blit_message("HOOK --> RUN",400);
		execEboot("ms0:/PSP/PSPluginInfoPRX/update/EBOOT.PBP");
	}
	if(sceKernelFindModuleByName("camera_plugin_module"))
	{
	    blit_message("HOOK --> RUN",400);
		execEboot("ms0:/PSP/PSPluginInfoPRX/camera/EBOOT.PBP");
	}
	if(sceKernelFindModuleByName("htmlviewer_plugin_module"))
    {
        blit_message("HOOK --> RUN",400);
        execEboot("ms0:/PSP/PSPluginInfoPRX/customwebbrowser/EBOOT.PBP");
    }

}



void setupUsb()
{
	loadStartModule("flash0:/kd/semawm.prx",0,NULL);
	loadStartModule("flash0:/kd/usbstor.prx", 0, NULL);
	loadStartModule("flash0:/kd/usbstormgr.prx", 0, NULL);
	loadStartModule("flash0:/kd/usbstorms.prx", 0, NULL);
	loadStartModule("flash0:/kd/usbstorboot.prx", 0, NULL);
	sceUsbStart(PSP_USBBUS_DRIVERNAME, 0, 0);
	sceUsbStart(PSP_USBSTOR_DRIVERNAME, 0, 0);
	sceUsbstorBootSetCapacity(0x800000);
}


static u32 adjust_alpha(u32 col)
{
	u32 alpha = col>>24;
	u8 mul;
	u32 c1,c2;

	if(alpha==0)    return col;
	if(alpha==0xff) return col;

	c1 = col & 0x00ff00ff;
	c2 = col & 0x0000ff00;
	mul = (u8)(255-alpha);
	c1 = ((c1*mul)>>8)&0x00ff00ff;
	c2 = ((c2*mul)>>8)&0x0000ff00;
	return (alpha<<24)|c1|c2;
}


int getMSfreeSpace(){
    unsigned int buf[5];
    unsigned int *pbuf = buf;
    sceIoDevctl("ms0:", 0x02425818, &pbuf, sizeof(pbuf), 0, 0);
    return buf[1]*buf[3]*buf[4];
}


void Pause23(int atemp)   // Fonction bourrin qui permet la pause
{
         int atempo;
         int atempo2;
         atempo = 0;

    while (atempo < atemp)
    {
       atempo++;
       atempo2 = 0;
       while (atempo2 < atemp) {atempo2++;}
    }
 }
